
// Soldat is distributed WITHOUT ANY WARRANTY.

#include "def.h"
#include "data.h"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/timeb.h>

posizione Pos_array[MAX_PLY];
mossa pv[MAX_PLY][MAX_PLY];
U64 hash_partita[MAX_HPLY];     
char re_attack[120][120];
tipo_tt tt[TABLESIZE+1];
U8 pezzi_loc[2][16]; 
char fen_best[256];
casella casa_vuota;
casella board[120];         
U64 tempo_tests;
posizione Pos;
int soldat;
U64 nodes;
int side;
int hply;
int ply;
int eval();
void init();
int input();
int get_ms();
mossa think();
void init_tables();
void takeback( mossa m );
void print_move( mossa m );
void set_fen( char *stringa );
int gen( mossa *lista_mosse );
int gen_qs( mossa *lista_mosse );
int make_move( mossa m, int sotto_scacco );
int sotto_attacco( int attaccante, int casa );
void azzera_hash(){ memset( tt, 0, (TABLESIZE+1) * sizeof(tipo_tt)); }
void init(){ set_fen( "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 1 0" ); }
U64 rand_64bit(){ return (((U64)rand())^((U64)rand()<< 16)^((U64)rand()<< 32)^((U64)rand()<< 48)); }

/////////////////////////////////////////////////////////////////////

int main(){
    
    printf("Soldat III Ver. %s \n", VERSIONE );

    mossa best;
    U8 c, i, n_mosse, mossa_legale;
    mossa lista_mosse[256];
    
    init_tables();
    init();
    azzera_hash();
    
    while(input())
        if( soldat == side ){
          
          best = think();
          c = SOTTO_SCACCO( side );
          n_mosse = gen( lista_mosse );
          mossa_legale = 0;
    
          for( i=0; i< n_mosse; i++)
              if( lista_mosse[i].from == best.from && lista_mosse[i].to == best.to && lista_mosse[i].flag == best.flag ){
                  if( make_move(lista_mosse[i], c )){ 
                      ply = 0;                                  
                      printf("move "); fflush(stdout); 
                      print_move(best); printf("\n"); fflush(stdout);
                      mossa_legale = 1;
                      break;
                      }
                  }
          
           if(!mossa_legale){
             if(c){
                if(!side) printf ("0-1 {Black Mates}\n");
                else printf ("1-0 {White Mates}\n");
                fflush(stdout);
                }    
             else{
                printf ("1/2-1/2 {Draw}\n");
                fflush(stdout);
                }
             init();
             soldat = NERO; 
             } 
                             
                  
          }
    
    return 0;   
    
 }


///////////////////////////////////////////////////////////////////////

int input(){

	U8 stringa[256];
	
	while(1){
	
	   fgets(stringa,256, stdin);
		
	   if(!strncmp("quit", stringa, 4 )){ 
          return 0;
          }
       
      else if(!strncmp("go", stringa, 2)){
          soldat = side;
		  return 1;
		  }
			
	   else if(!strncmp("force", stringa, 5)){
		  soldat = GRIGIO;
	      }
            
       else if(!strncmp("new", stringa, 3)){
          level.test = 0;
          init();
          azzera_hash();
          soldat = NERO;
          }
       else if(!strncmp("time", stringa, 4)){
			sscanf(stringa,"time %lf", &level.tempo_residuo);
			level.tempo_residuo *= 10;
			}
                
       else if(!strncmp("level", stringa, 5)){
            level.test = 0;
			sscanf(stringa,"level %d", &level.m_residue);
			if( level.m_residue <= 0){ level.m_residue = MOSSE_STANDARD; level.time_control = 0; }
			else level.time_control = level.m_residue;
			}
          
       else {
          
          U8 from = CASA_DA_MOSSA(stringa[0],stringa[1]);  
          U8 to = CASA_DA_MOSSA(stringa[2],stringa[3]); 
          U8 i, promo, n_mosse;
          U8 c = SOTTO_SCACCO( side );
          mossa lista_mosse[256];
    
          n_mosse = gen( lista_mosse );
          
          switch(stringa[4]){
             case 'q': promo = PROMO_D; break;
			 case 'r': promo = PROMO_T; break;
			 case 'n': promo = PROMO_C; break;
			 case 'b': promo = PROMO_A; break;
			 default: promo = 0;
 			 }
          
          for( i=0; i< n_mosse; i++)
             if( lista_mosse[i].from == from && lista_mosse[i].to == to ){
                 
                if( !promo || (lista_mosse[i].flag & promo) ){ 
                     if( make_move( lista_mosse[i], c )){
                         ply = 0; 
                         return 1;
                         }
                     }
              
               else if( promo == PROMO_T && (lista_mosse[i].flag & PROMO_D )){
                    if( make_move( lista_mosse[i], c )){
                         board[to].pezzo = TORRE;
                         board[to].flag ^= ( FLAG_TORRE | FLAG_DONNA );
                         Pos.index ^= zobrist.pezzi[side^1][TORRE][to] ^ zobrist.pezzi[side^1][DONNA][to]; ; 
                         Pos.materiale[side^1] -= valore_pezzi[DONNA];
                         Pos.materiale[side^1] += valore_pezzi[TORRE];
                         ply = 0; 
                         return 1;
                         }
                    }
                
                else if( promo == PROMO_A && (lista_mosse[i].flag & PROMO_D )){
                    if( make_move( lista_mosse[i], c )){
                         board[to].pezzo = ALFIERE;
                         board[to].flag ^= ( FLAG_ALFIERE | FLAG_DONNA );
                         Pos.index ^= zobrist.pezzi[side^1][ALFIERE][to] ^ zobrist.pezzi[side^1][DONNA][to]; ; 
                         Pos.materiale[side^1] -= valore_pezzi[DONNA];
                         Pos.materiale[side^1] += valore_pezzi[ALFIERE];
                         ply = 0; 
                         return 1;
                         }
                    }    
              }
           }
	    }
	
	return 1;

}

///////////////////////////////////////////////////////////////////////

void set_fen( char *init_fen ){
    
    int i = 0, e;
    char fen[256]; 
    char *fen_best_move;
    
    // copiamo la stringa in una temporanea
    while( init_fen[i] != '\0'){ fen[i] = init_fen[i]; i++; }
    
    for(i=0;i<120;i++) board[i] = casa_vuota;
    
    i=0, e=0;
    
    while(init_fen[e] != ' '){
                       
         switch ( init_fen[e] ){
                case '/':   i--; 
                            break;
                case 'p':   board[loop_64[i]].pezzo = PEDONE; 
                            board[loop_64[i]].colore = NERO;
                            board[loop_64[i]].flag = FLAG_PEDONE | FLAG_NERO;
                            break; 
                case 'r':   board[loop_64[i]].pezzo = TORRE; 
                            board[loop_64[i]].colore = NERO;
                            board[loop_64[i]].flag = FLAG_TORRE | FLAG_NERO;
                            break; 
                case 'n':   board[loop_64[i]].pezzo = CAVALLO; 
                            board[loop_64[i]].colore = NERO;
                            board[loop_64[i]].flag = FLAG_CAVALLO | FLAG_NERO;
                            break; 
                case 'b':   board[loop_64[i]].pezzo = ALFIERE; 
                            board[loop_64[i]].colore = NERO;
                            board[loop_64[i]].flag = FLAG_ALFIERE | FLAG_NERO;
                            break; 
                case 'k':   board[loop_64[i]].pezzo = RE; 
                            board[loop_64[i]].colore = NERO;
                            board[loop_64[i]].flag = FLAG_RE | FLAG_NERO;
                            Pos.re[NERO] = loop_64[i];
                            break; 
                case 'q':   board[loop_64[i]].pezzo = DONNA; 
                            board[loop_64[i]].colore = NERO;
                            board[loop_64[i]].flag = FLAG_DONNA | FLAG_NERO;
                            break;
                case 'P':   board[loop_64[i]].pezzo = PEDONE; 
                            board[loop_64[i]].colore = BIANCO;
                            board[loop_64[i]].flag = FLAG_PEDONE | FLAG_BIANCO;
                            break; 
                case 'R':   board[loop_64[i]].pezzo = TORRE; 
                            board[loop_64[i]].colore = BIANCO;
                            board[loop_64[i]].flag = FLAG_TORRE | FLAG_BIANCO;
                            break; 
                case 'N':   board[loop_64[i]].pezzo = CAVALLO; 
                            board[loop_64[i]].colore = BIANCO;
                            board[loop_64[i]].flag = FLAG_CAVALLO | FLAG_BIANCO;
                            break; 
                case 'B':   board[loop_64[i]].pezzo = ALFIERE; 
                            board[loop_64[i]].colore = BIANCO;
                            board[loop_64[i]].flag = FLAG_ALFIERE | FLAG_BIANCO;
                            break; 
                case 'K':   board[loop_64[i]].pezzo = RE; 
                            board[loop_64[i]].colore = BIANCO;
                            board[loop_64[i]].flag = FLAG_RE | FLAG_BIANCO;
                            Pos.re[BIANCO] = loop_64[i];
                            break; 
                case 'Q':   board[loop_64[i]].pezzo = DONNA; 
                            board[loop_64[i]].colore = BIANCO;
                            board[loop_64[i]].flag = FLAG_DONNA | FLAG_BIANCO;
                            break;
                default:    if(isdigit(init_fen[e])) i+= init_fen[e] - 49;
                            else printf("Errore tipo pezzo in set_fen()\n");          
                }
         i++;
         e++;
         }
      
      if( i != 64 ) printf("Errore n. case in set_fen()\n");
      
      if(init_fen[++e]=='w') side = BIANCO;
      else if(init_fen[e]=='b') side = NERO;
      else printf("set_fen() errore colore");
         
      e+=2;
         
      Pos.arrocco = 0;
      while(init_fen[e] != ' '){
          switch(init_fen[e]){
             case 'K': Pos.arrocco |= ARROCCO_BC; break;
             case 'Q': Pos.arrocco |= ARROCCO_BL; break;
             case 'k': Pos.arrocco |= ARROCCO_NC; break;
             case 'q': Pos.arrocco |= ARROCCO_NL; break;
             case '-': break;
             default: printf("set_fen() errore arrocco\n");
             }
          e++;
          }
          
     e++;
          
     Pos.ep = (init_fen[e]=='-') ? OFF_BOARD : CASA_DA_MOSSA( init_fen[e], init_fen[e+1] );
     if(( Pos.ep & 0x88 ) && Pos.ep != OFF_BOARD) printf( "set_fen() errore casella ep\n");
            
     soldat = GRIGIO;
     Pos.fifty = 0;
     ply = 0;
     hply = 0;
      
     Pos.pezzi_tot[BIANCO] = 0; 
     Pos.pezzi_tot[NERO] = 0;
     Pos.materiale[BIANCO] = 0;
     Pos.materiale[NERO] = 0; 
     Pos.index = 0;
     
     for(i=0;i<120;i++)
        if((e = board[i].colore) != NO_COLORE ){
            board[i].pezzo_loc = Pos.pezzi_tot[e];
            pezzi_loc[e][Pos.pezzi_tot[e]] = i;
            Pos.pezzi_tot[e]++;
            Pos.materiale[e] += valore_pezzi[board[i].pezzo];
            Pos.index ^= zobrist.pezzi[e][board[i].pezzo][i];
            }    
         
     if( side ) Pos.index ^= zobrist.side;
     Pos.index ^= zobrist.ep[Pos.ep];
     Pos.index ^= zobrist.arrocco[Pos.arrocco];
     
     strcpy(fen_best, "none");
     fen_best_move = strtok( fen , " ");
     while( fen_best_move != NULL){ 
        if( strcmp(  fen_best_move, "bm") == 0){
           fen_best_move = strtok( NULL , ";");
           strcpy(fen_best, fen_best_move);
           }
        fen_best_move = strtok(NULL, " ");
        }    
}

////////////////////////////////////////////////////////////////////////

int gen( mossa *lista_mosse ){
    
    int f, i, s, to, *var;
    
    mossa *mossaPtr = lista_mosse;
    
         
    for( f=0; f < Pos.pezzi_tot[side]; f++ ) {      
      
      i = pezzi_loc[side][f];
      
      // se la mossa e' di pedone
       if( board[i].pezzo == PEDONE ){
          // no promozione
          if( TRA(i) != tra_promo[side] ){         
             for( s=0; s<3; s++ )
                if( IS_BOARD((to = i + mpe[side][s])) && board[to].colore == ok_mpe[side][s] ){
                   mossaPtr->from = i;
                   mossaPtr->to = to;
                   mossaPtr++->flag = cat_pezzi[board[to].colore]; 
                   if( s == 2 && TRA(to) == tra_spinta2[side] && !board[(to += mpe[side][s])].pezzo ){
                      mossaPtr->from = i;
                      mossaPtr->to = to;
                      mossaPtr++->flag = SPINTA_DUE ;  
                      } 
                   }
                }
          // promozione
          else{         
             for( s=0; s<3; s++ )
                if( IS_BOARD((to = i + mpe[side][s])) && board[to].colore == ok_mpe[side][s] ){              
                   mossaPtr->from = i;
                   mossaPtr->to = to;
                   mossaPtr++->flag = PROMO_D | cat_pezzi[board[to].colore];
                   mossaPtr->from = i;
                   mossaPtr->to = to;
                   mossaPtr++->flag = PROMO_C | cat_pezzi[board[to].colore];
                   }
                }
             }
        
              
       // alfiere, torre e donna
       else if( IS_SLIDE( board[i].pezzo )){ 
         
         if( board[i].flag & 0x30 )// t+d   
          for( var = mosse_pezzi[TORRE]; *var; var++ ){ 
             for( to = i + *var; IS_BOARD(to); to += *var ){
                if( board[to].colore != side ){
                   mossaPtr->from = i;
                   mossaPtr->to = to;
                   mossaPtr++->flag = cat_pezzi[board[to].colore];
                   }
                if(board[to].pezzo) break;
                }
             }
         if( board[i].flag & 0x28 )// a+d      
          for( var = mosse_pezzi[ALFIERE]; *var; var++ ){ 
             for( to = i + *var; IS_BOARD(to); to += *var ){
                if( board[to].colore != side ){
                   mossaPtr->from = i;
                   mossaPtr->to = to;
                   mossaPtr++->flag = cat_pezzi[board[to].colore];
                   }
                if(board[to].pezzo) break;
                }
             }   
             
             
          }
            
       // re e cavallo
       else for( var = mosse_pezzi[board[i].pezzo]; *var; var++ ){   
          if( IS_BOARD((to = i + *var)) && board[to].colore != side ){
             mossaPtr->from = i;
             mossaPtr->to = to;
             mossaPtr++->flag = cat_pezzi[board[to].colore];
             }
          }               
     }
               
   // pseudomosse di arrocco se non siamo sotto scacco  
   if( Pos.arrocco & ARROCCO ){
      if( side == BIANCO ){                            
         if((Pos.arrocco & ARROCCO_BC) && !board[F1].pezzo && !board[G1].pezzo ){
             mossaPtr->from = E1;
             mossaPtr->to = G1;
             mossaPtr++->flag = ARROCCO_BC;
             }   
         if((Pos.arrocco & ARROCCO_BL) && !board[B1].pezzo && !board[C1].pezzo && !board[D1].pezzo ){
             mossaPtr->from = E1;
             mossaPtr->to = C1;
             mossaPtr++->flag = ARROCCO_BL;                          
            }    
         }  
      else {                           
         if((Pos.arrocco & ARROCCO_NC) && !board[F8].pezzo && !board[G8].pezzo ){
             mossaPtr->from = E8;
             mossaPtr->to = G8;
             mossaPtr++->flag = ARROCCO_NC;
             }   
         if((Pos.arrocco & ARROCCO_NL) && !board[B8].pezzo && !board[C8].pezzo && !board[D8].pezzo ){
             mossaPtr->from = E8;
             mossaPtr->to = C8;
             mossaPtr++->flag = ARROCCO_NL;                          
            }       
         } 
   } 
      
   // catture ep  
   if( !(Pos.ep & 0x88)){
       int from;
       if( TRA(Pos.ep) == tra_ep[side]){
           for( s=0; s<2; s++ ){
                from = Pos.ep - mpe[side][s];
                if( IS_BOARD(from) && board[from].pezzo == PEDONE && board[from].colore == side ){
                    mossaPtr->from = from;
                    mossaPtr->to = Pos.ep;
                    mossaPtr++->flag = CATTURA_EP;                          
                    }
                }       
           }  
       }


    return mossaPtr - lista_mosse;   
    
}

////////////////////////////////////////////////////////////////////////

int gen_qs( mossa *lista_mosse ){
    
    int f, i, s, to, *var;
    
    mossa *mossaPtr = lista_mosse;
    
         
    for( f=0; f < Pos.pezzi_tot[side]; f++ ) {      
      
      i = pezzi_loc[side][f];
      
      // se la mossa e' di pedone
       if( board[i].pezzo == PEDONE ){
          // cattura senza promozione
          if( TRA(i) != tra_promo[side] ){         
             for( s=0; s<3; s++ )
                if( IS_BOARD((to = i + mpe[side][s])) && board[to].colore == !side ){
                   mossaPtr->from = i;
                   mossaPtr->to = to;
                   mossaPtr++->flag = CATTURA; 
                   }
                }
          // promozione solo a donna
          else{         
             for( s=0; s<3; s++ )
                if( IS_BOARD((to = i + mpe[side][s])) && board[to].colore == ok_mpe[side][s] ){              
                   mossaPtr->from = i;
                   mossaPtr->to = to;
                   mossaPtr++->flag = PROMO_D | cat_pezzi[board[to].colore];
                   }
                }
             }
        
              
       // alfiere, torre e donna
       else if( IS_SLIDE( board[i].pezzo )){ 
         
         if( board[i].flag & 0x30 )// t+d   
          for( var = mosse_pezzi[TORRE]; *var; var++ ){ 
             for( to = i + *var; IS_BOARD(to); to += *var ){
                if( board[to].colore == !side ){
                   mossaPtr->from = i;
                   mossaPtr->to = to;
                   mossaPtr++->flag = CATTURA;
                   }
                if(board[to].pezzo) break;
                }
             }
         if( board[i].flag & 0x28 )// a+d      
          for( var = mosse_pezzi[ALFIERE]; *var; var++ ){ 
             for( to = i + *var; IS_BOARD(to); to += *var ){
                if( board[to].colore == !side ){
                   mossaPtr->from = i;
                   mossaPtr->to = to;
                   mossaPtr++->flag = CATTURA;
                   }
                if(board[to].pezzo) break;
                }
             }   
             
             
          }
            
       // re e cavallo
       else for( var = mosse_pezzi[board[i].pezzo]; *var; var++ ){   
          if( IS_BOARD((to = i + *var)) && board[to].colore == !side ){
             mossaPtr->from = i;
             mossaPtr->to = to;
             mossaPtr++->flag = CATTURA;
             }
          } 
                   
     }
      
   // catture ep  
   if( !(Pos.ep & 0x88)){
       int from;
       if( TRA(Pos.ep) == tra_ep[side]){
           for( s=0; s<2; s++ ){
                from = Pos.ep - mpe[side][s];
                if( IS_BOARD(from) && board[from].pezzo == PEDONE && board[from].colore == side ){
                    mossaPtr->from = from;
                    mossaPtr->to = Pos.ep;
                    mossaPtr++->flag = CATTURA_EP;                          
                    }
                }       
           }  
       }


    return mossaPtr - lista_mosse;   
    
}

////////////////////////////////////////////////////////////////////////

void print_move( mossa m ){
     
     printf("%c%c%c%c", 'a'+COL(m.from),'1'+TRA(m.from),'a'+COL(m.to),'1'+TRA(m.to));
     
     if( m.flag & PROMOZIONE ){
        if(m.flag & PROMO_D)putchar('q');
        else if(m.flag & PROMO_T)putchar('r'); 
        else if(m.flag & PROMO_A)putchar('b'); 
        else if(m.flag & PROMO_C)putchar('n'); 
        else printf("print_move() Promozione errata");    
        }
          
     putchar(' ');              
}

////////////////////////////////////////////////////////////////////////


int sotto_attacco(int attaccante, int casa){
     
  int to, *var;
  
  // attaccante pedone o cavallo nero
  if( attaccante ){
     if( IS_BOARD((to = casa + 15)) && (board[to].flag == 0x81)) return 1;
     if( IS_BOARD((to = casa + 17)) && (board[to].flag == 0x81)) return 1;
     if( IS_BOARD((to = casa + 14)) && (board[to].flag == 0x82)) return 1; 
     if( IS_BOARD((to = casa + 31)) && (board[to].flag == 0x82)) return 1; 
     if( IS_BOARD((to = casa + 33)) && (board[to].flag == 0x82)) return 1; 
     if( IS_BOARD((to = casa + 18)) && (board[to].flag == 0x82)) return 1; 
     if( IS_BOARD((to = casa - 14)) && (board[to].flag == 0x82)) return 1; 
     if( IS_BOARD((to = casa - 31)) && (board[to].flag == 0x82)) return 1; 
     if( IS_BOARD((to = casa - 33)) && (board[to].flag == 0x82)) return 1; 
     if( IS_BOARD((to = casa - 18)) && (board[to].flag == 0x82)) return 1; 
     }
              
   else{
     if( IS_BOARD((to = casa - 15)) && (board[to].flag == 0x41)) return 1;
     if( IS_BOARD((to = casa - 17)) && (board[to].flag == 0x41)) return 1;
     if( IS_BOARD((to = casa + 14)) && (board[to].flag == 0x42)) return 1; 
     if( IS_BOARD((to = casa + 31)) && (board[to].flag == 0x42)) return 1; 
     if( IS_BOARD((to = casa + 33)) && (board[to].flag == 0x42)) return 1; 
     if( IS_BOARD((to = casa + 18)) && (board[to].flag == 0x42)) return 1; 
     if( IS_BOARD((to = casa - 14)) && (board[to].flag == 0x42)) return 1; 
     if( IS_BOARD((to = casa - 31)) && (board[to].flag == 0x42)) return 1; 
     if( IS_BOARD((to = casa - 33)) && (board[to].flag == 0x42)) return 1; 
     if( IS_BOARD((to = casa - 18)) && (board[to].flag == 0x42)) return 1; 
     }     
     
     for( var = mosse_pezzi[TORRE]; *var; var++ )
        if( IS_BOARD((to = casa + *var))){ 
           if( board[to].colore == attaccante && ( board[to].flag & 0x34 )) return 1; // r+t+d
           if( board[to].pezzo ) continue;
           for( to += *var; IS_BOARD(to); to += *var ){
              if(!board[to].pezzo) continue; 
              if( board[to].colore == attaccante && ( board[to].flag & 0x30 )) return 1; // t+d
              break;
              }
           }
                
     for( var = mosse_pezzi[ALFIERE]; *var; var++ )
        if( IS_BOARD((to = casa + *var))){ 
           if( board[to].colore == attaccante && ( board[to].flag & 0x2C )) return 1; // r+a+d
           if( board[to].pezzo ) continue;
           for( to += *var; IS_BOARD(to); to += *var ){
              if(!board[to].pezzo) continue; 
              if( board[to].colore == attaccante && ( board[to].flag & 0x28 )) return 1; // a+d
              break;
              }
           } 
    
             
                      
    return 0;   
 
}

////////////////////////////////////////////////////////////////////////


int make_move( mossa m, int c ){
    
    // Facciamo il debug della posizione per il take_back();
    Pos_array[ply] = Pos; 
    
     // Se  una mossa di arrocco e questo  legale si spostano le torri
     if( m.flag & ARROCCO ){ 
         
         if(c) return 0;
         
         if( m.flag & ARROCCO_BC) {
            if( sotto_attacco(NERO, F1) ||  sotto_attacco(NERO, G1)) return 0;
            pezzi_loc[BIANCO][board[H1].pezzo_loc] = F1; 
            board[F1] = board[H1]; 
            board[H1] = casa_vuota;
            Pos.index ^= zobrist.pezzi[BIANCO][TORRE][H1] ^ zobrist.pezzi[BIANCO][TORRE][F1];  
            }
         else if( m.flag & ARROCCO_BL) {
            if( sotto_attacco(NERO, C1) ||  sotto_attacco(NERO, D1)) return 0;
            pezzi_loc[BIANCO][board[A1].pezzo_loc] = D1; 
            board[D1] = board[A1]; 
            board[A1] = casa_vuota;
            Pos.index ^= zobrist.pezzi[BIANCO][TORRE][A1] ^ zobrist.pezzi[BIANCO][TORRE][D1];   
            }   
         else if( m.flag & ARROCCO_NC) {
            if( sotto_attacco(BIANCO, F8) ||  sotto_attacco(BIANCO, G8)) return 0;
            pezzi_loc[NERO][board[H8].pezzo_loc] = F8; 
            board[F8] = board[H8]; 
            board[H8] = casa_vuota;
            Pos.index ^= zobrist.pezzi[NERO][TORRE][H8] ^ zobrist.pezzi[NERO][TORRE][F8];  
            }  
         else if( m.flag & ARROCCO_NL) {
            if( sotto_attacco(BIANCO, C8) ||  sotto_attacco(BIANCO, D8)) return 0;
            pezzi_loc[NERO][board[A8].pezzo_loc] = D8; 
            board[D8] = board[A8]; 
            board[A8] = casa_vuota;
            Pos.index ^= zobrist.pezzi[NERO][TORRE][A8] ^ zobrist.pezzi[NERO][TORRE][D8]; 
            } 
             
         }
          
                     
    // Regola della patta per le 50 mosse
    if(( board[m.from].pezzo == PEDONE) || ( m.flag & CATTURA ) ) Pos.fifty = 0;
    else Pos.fifty++;
    
    // Cambiamo la posizione del re prima di spostare i pezzi
    if( board[m.from].pezzo == RE )Pos.re[side] = m.to;
        
    // se c' una cattura
    if( m.flag & CATTURA_EP ){
        Pos.materiale[side^1] -= valore_pezzi[PEDONE];
        Pos.pezzi_tot[side^1]--;  
        board[pezzi_loc[side^1][Pos.pezzi_tot[side^1]]].pezzo_loc = board[m.to - mpe[side][2]].pezzo_loc;
        pezzi_loc[side^1][board[m.to - mpe[side][2]].pezzo_loc] = pezzi_loc[side^1][Pos.pezzi_tot[side^1]];
        board[m.to - mpe[side][2]] = casa_vuota;
        Pos.index ^= zobrist.pezzi[side^1][PEDONE][m.to - mpe[side][2]]; 
        }
    else if(m.flag & CATTURA ){
        Pos.index ^= zobrist.pezzi[side^1][board[m.to].pezzo][m.to];  
        Pos.materiale[side^1] -= valore_pezzi[board[m.to].pezzo];
        Pos_array[ply].cattura = board[m.to].pezzo | ( board[m.to].colore << 3);        
        Pos.pezzi_tot[side^1]--;    
        board[pezzi_loc[side^1][Pos.pezzi_tot[side^1]]].pezzo_loc = board[m.to].pezzo_loc;
        pezzi_loc[side^1][board[m.to].pezzo_loc] = pezzi_loc[side^1][Pos.pezzi_tot[side^1]];
        }     
        
             
    // Spostiamo i pezzi e le posizioni negli array
    Pos.index ^= zobrist.pezzi[side][board[m.from].pezzo][m.to] ^ 
                 zobrist.pezzi[side][board[m.from].pezzo][m.from] ^ 
                 zobrist.side;
    pezzi_loc[side][board[m.from].pezzo_loc] = m.to;
    board[m.to] = board[m.from]; 
    board[m.from] = casa_vuota; 
    
    // C' una promozione ?
    if( m.flag & PROMOZIONE ){ 
        if( m.flag & PROMO_D ){
            board[m.to].pezzo = DONNA;
            board[m.to].flag ^= ( FLAG_DONNA | FLAG_PEDONE ); 
            Pos.index ^= zobrist.pezzi[side][DONNA][m.to] ^
                         zobrist.pezzi[side][PEDONE][m.to];  
            }
        else{
            board[m.to].pezzo = CAVALLO;
            board[m.to].flag ^= ( FLAG_CAVALLO | FLAG_PEDONE );
            Pos.index ^= zobrist.pezzi[side][CAVALLO][m.to] ^
                         zobrist.pezzi[side][PEDONE][m.to]; ; 
            }
        Pos.materiale[side] -= valore_pezzi[PEDONE];
        Pos.materiale[side] += valore_pezzi[board[m.to].pezzo];
        }
    
    // Modifichiamo il diritto di arrocco
    if( Pos.arrocco & ARROCCO ){ 
        U8 temp_castle = Pos.arrocco;
        Pos.arrocco &= (bit_castle[m.from] & bit_castle[m.to]);
        Pos.index ^= zobrist.arrocco[Pos.arrocco] ^ zobrist.arrocco[temp_castle];
        }
        
    // C' una spinta di due ? 
    U8 temp_ep = Pos.ep;
    if( m.flag & SPINTA_DUE )Pos.ep =  m.to - mpe[side][2]; 
    else Pos.ep = OFF_BOARD;
    Pos.index ^= zobrist.ep[Pos.ep] ^ zobrist.ep[temp_ep];
         
    // Modifichiamo le altre variabili
    side ^= 1;
    hply++;
    ply++;
    
    hash_partita[hply] = Pos.index; 
    
    // le mosse di arrocco sono sicuramente legali
    if( m.flag & ARROCCO ) return 1;
     
    // se non si era sotto scacco e non si  fatta una mossa di re verifichiamo le scoperte
    if( !c && board[m.to].pezzo != RE ){ 
         
         if( angoli[m.from] ) return 1;
         
         int to, var = re_attack[Pos.re[side^1]][m.from];
         
         switch(var){
            
            case 0 : return 1;
         
            case 1: case -1: case 16: case -16:   
                 for( to = Pos.re[side^1] + var; IS_BOARD(to); to += var ) {
                    if( !board[to].flag ) continue;
                    if( board[to].colore == side && ( board[to].flag & 0x30 )) {  // t+d
                        takeback(m);  
                        return 0; 
                        }
                    else return 1;
                    } 
                 return 1;
            
            case 15: case -15: case 17: case -17:   
                 for( to = Pos.re[side^1] + var; IS_BOARD(to); to += var ) {
                    if(  !board[to].flag  ) continue;
                    if( board[to].colore == side && ( board[to].flag & 0x28 )) {  // a+d
                        takeback(m);  
                        return 0; 
                        }
                    else return 1;
                    } 
                 return 1;
                 
            }
         
         }
         
     // altrimenti se si era sotto scacco o si  fatta una mossa di re
     if( SOTTO_SCACCO( side ^ 1 )){ takeback(m);  return 0; }
      
     return 1; 
     
     
 }
 
////////////////////////////////////////////////////////////////////////
 
void takeback( mossa m ){
      
     ply--;
     hply--;
	 side ^= 1;
     Pos = Pos_array[ply];
     
     // C' una promozione ?
     if( m.flag & PROMOZIONE ){ 
         board[m.to].pezzo = PEDONE;
         board[m.to].flag &= FLAG_COLORE;
         board[m.to].flag |= FLAG_PEDONE;
         }
      
     // Spostiamo i pezzi e le posizioni negli array
     pezzi_loc[side][board[m.to].pezzo_loc] = m.from;
     board[m.from] = board[m.to]; 
     
     if( m.flag & CATTURA_EP ){ 
        pezzi_loc[side^1][Pos.pezzi_tot[side^1]-1] = m.to - mpe[side][2];
        board[m.to - mpe[side][2]].pezzo_loc = Pos.pezzi_tot[side^1]-1;   
        board[m.to - mpe[side][2]].pezzo = PEDONE;
        board[m.to - mpe[side][2]].colore = (side)? BIANCO : NERO ;
        board[m.to] = casa_vuota;
        board[m.to - mpe[side][2]].flag = FLAG_PEDONE;
        board[m.to - mpe[side][2]].flag |= (side) ? FLAG_BIANCO : FLAG_NERO ;
         
        }
     else if( m.flag & CATTURA ){ 
        pezzi_loc[side^1][Pos.pezzi_tot[side^1]-1] = m.to;
        board[m.to].pezzo_loc = Pos.pezzi_tot[side^1]-1;
        board[m.to].pezzo = Pos_array[ply].cattura & 7;
        board[m.to].colore = Pos_array[ply].cattura >> 3;
        board[m.to].flag = ( 1 << ( board[m.to].pezzo - 1));
        board[m.to].flag |= (side) ? FLAG_BIANCO : FLAG_NERO ;
            
        }
     else board[m.to] = casa_vuota;   
        
     // rimettiamo a posto la torre se c'e' stato l'arrocco
     if( m.flag & ARROCCO ){
         if( m.flag & ARROCCO_BC) {
            pezzi_loc[BIANCO][board[F1].pezzo_loc] = H1; 
            board[H1] = board[F1]; 
            board[F1] = casa_vuota; 
            } 
         else if( m.flag & ARROCCO_BL) {
            pezzi_loc[BIANCO][board[D1].pezzo_loc] = A1; 
            board[A1] = board[D1]; 
            board[D1] = casa_vuota; 
            }                 
         else if( m.flag & ARROCCO_NC) {
            pezzi_loc[NERO][board[F8].pezzo_loc] = H8; 
            board[H8] = board[F8]; 
            board[F8] = casa_vuota; 
            }  
         else if( m.flag & ARROCCO_NL) {
            pezzi_loc[NERO][board[D8].pezzo_loc] = A8; 
            board[A8] = board[D8]; 
            board[D8] = casa_vuota; 
            }       
         }
           
     }

////////////////////////////////////////////////////////////////////////


int get_ms(){
    
    struct timeb timebuffer;
	ftime(&timebuffer);
	return (timebuffer.time * 1000) + timebuffer.millitm;
  
  }
  
////////////////////////////////////////////////////////////////////////

void init_tables(){
   
   casa_vuota.pezzo = NO_PEZZO;
   casa_vuota.colore = NO_COLORE;
   casa_vuota.flag = NO_FLAG;
   casa_vuota.pezzo_loc = 88;
    
   int i, e, a, to, *var;
   
   for(i=0;i<120;i++)     
       for(e=0;e<120;e++) re_attack[i][e] = 0;   
     
   for(i=0;i<120;i++)
      for( var = mosse_pezzi[RE]; *var; var++ )
         for( to = i + *var; IS_BOARD(to); to += *var ) re_attack[i][to] = *var; 
         
         
   zobrist.side = rand_64bit();
   for(i=0;i<120;i++) zobrist.ep[i] = rand_64bit();
   for(i=0;i<16;i++) zobrist.arrocco[i] = rand_64bit();
     
   for(a=0;a<2;a++)
      for(e=0;e<7;e++)
        for(i=0;i<120;i++) zobrist.pezzi[a][e][i] = rand_64bit();
        
                        
}

//////////////////////////////////////////////////////////////////////////
// ***********************************************************************
// THINK  ****************************************************************
// ***********************************************************************
//////////////////////////////////////////////////////////////////////////

int max_ply_raggiunto;
double tempo_massimo;
mossa kill1[MAX_PLY];
mossa kill2[MAX_PLY];
int history[120][120];
int max_iteractions;
int start_time;
char triplice();
int cut;
void make_null( );
void back_null( );
double get_tempo_mossa();
void aggiorna_pv( short score );
short quiesce( short alpha, short beta );
void sort_qs( mossa *mosse, U8 n );
short search( char depth, short alpha, short beta );
void prima_mossa( U8 f, mossa *mosse, U8 n_mosse );
void sort_ab( U8 b_from, U8 b_to, mossa *mosse, U8 n );
short search_tt( int depth, short alpha, short beta, char next_c, char null, U8 last_cap_to );

//////////////////////////////////////////////////////////////////////////

double get_tempo_mossa(){

	double tempo_temp ;
	
	if( level.test ) return tempo_tests;
	
	if( level.time_control != 0 ){
		tempo_temp = level.tempo_residuo / (level.m_residue+1);
		if(--level.m_residue == 0) level.m_residue += level.time_control;
		return tempo_temp;
		}
	
	else{
		tempo_temp = level.tempo_residuo / level.m_residue;
		if(--level.m_residue < 10) level.m_residue = 10;
		return tempo_temp;
		}

	return 0;

}

//////////////////////////////////////////////////////////////////////////


mossa think(){
   
   int i, x, score, ply_limit = MAX_PLY;
   nodes = 0;
   mossa best;
   cut =0;
   
   tempo_massimo = get_tempo_mossa();
   
   // si azzera la variante principale
   for(i=0;i<MAX_PLY;i++){
	   for(x=0;x<MAX_PLY;x++){
          pv[i][x].from = 0;
          pv[i][x].to = 0;
          pv[i][x].flag = 0;
          }
       }
   
    for(i=0;i<120;i++)
	   for(x=0;x<120;x++)history[i][x] = 0;
	   
   if( level.test == SUPERSPEED ) ply_limit = 16;
          
   start_time = get_ms();
   
   for( i=1; i<=ply_limit; i++){
   
      max_iteractions = i;
      max_ply_raggiunto = 1;
     
      score = search( i, -INFINITO, INFINITO );
    
      if( abs(score) != EXIT_SEARCH ) best = pv[0][0];
      else break;
      
      if( !level.test && ((get_ms() - start_time) * FATTORE_DI_RICERCA ) > tempo_massimo ) break;
      
      if( score > 9000 ) break;
      
      }
      
   printf("cut %d\n", cut);
   
   return best; 
      
}

//////////////////////////////////////////////////////////////////////////


short search( char depth, short alpha, short beta ){
    
    U8 i, e, n_mosse, mosse_ab = 0, next_c;
    U8 c = SOTTO_SCACCO( side );
    mossa lista_mosse[256];
    mossa best_tt;	
    short score;
    
    int tt_loc = Pos.index % TABLESIZE;
    
    n_mosse = gen( lista_mosse );
    
    if( tt[tt_loc].index == Pos.index ) sort_ab( tt[tt_loc].from,  tt[tt_loc].to, lista_mosse, n_mosse );
    else sort_ab( 0,  0, lista_mosse, n_mosse );
    
    for( i=0; i< n_mosse; i++ ){
          if(( get_ms() - start_time ) > tempo_massimo ) return EXIT_SEARCH;
          prima_mossa( i, lista_mosse, n_mosse );
          if( make_move(lista_mosse[i], c )){
              
              next_c = SOTTO_SCACCO( side );
              
              U8 cap_to = (lista_mosse[i].flag & CATTURA) ? lista_mosse[i].to : 0x0a;
              
              if( mosse_ab ){
                 score = -search_tt( depth-1, -alpha-1,-alpha, next_c, 1, cap_to);
                 if( score > alpha && score < beta) score = -search_tt( depth-1, -beta, -alpha, next_c, 1, cap_to );
                 }  
              else  score = -search_tt( depth-1, -beta, -alpha, next_c, 1, cap_to );
              
              takeback( lista_mosse[i] );
              mosse_ab++;
              nodes++; 
              
              if( abs(score) == EXIT_SEARCH ) return EXIT_SEARCH;
              
              if( score > alpha){ 
                 alpha = score; 
                 pv[ply][ply] = lista_mosse[i];
                 for( e=ply+1; e < max_ply_raggiunto; e++ )pv[ply][e] = pv[ply+1][e];
                 aggiorna_pv( score );
                 best_tt = lista_mosse[i];
                 } 
              }
          }
              
    if(mosse_ab == 0){
	   if(c) alpha = ( -INFINITO + ply );
	   else alpha = 0;
	   }
	
    if( mosse_ab == 1 ) return 9500;
       
    if( tt[tt_loc].depth <= depth ){
        tt[tt_loc].depth = depth;
        tt[tt_loc].flag  = EXACT;
        tt[tt_loc].index = Pos.index;
        tt[tt_loc].score = alpha;
        tt[tt_loc].from = best_tt.from;
        tt[tt_loc].to = best_tt.to;
        }  
              
    return alpha;

}

//////////////////////////////////////////////////////////////////////////


short search_tt( int depth, short alpha, short beta, char c, char null, U8 last_cap_to ){
    
    short i, e, score, n_mosse, mosse_ab = 0, pv_found = 0;
    mossa best_tt, lista_mosse[256];
    char next_c, tt_flag = UPPER;
    	
    
    if(!(nodes % 1024) && ( get_ms() - start_time ) > tempo_massimo ) return EXIT_SEARCH;
    for ( i = hply - Pos.fifty; i < hply; i++ ) if( hash_partita[i] == Pos.index ) return 0;
    if( ply >= MAX_PLY ) return eval();
    if( Pos.fifty >= 100 ) return 0;
    
    // *** Estensioni per scacco ***
    if(c) depth++;
    else if(depth <= 0) return quiesce( alpha, beta );
    
    
    // *** Transposiotion tables ***
    int tt_loc = Pos.index % TABLESIZE;
    if( tt[tt_loc].depth >= depth && tt[tt_loc].index == Pos.index ){
        if (( tt[tt_loc].flag == LOWER ) && ( tt[tt_loc].score >= beta)) return beta; 
        if (( tt[tt_loc].flag == UPPER ) && ( tt[tt_loc].score <= alpha)) return alpha;
        if (  tt[tt_loc].flag == EXACT ) return tt[tt_loc].score;    
        } 
    
    // *** Null moves reduction *** 
    char danger = 0;
    if( !c && null && depth > 1 ){ 
          char R = ((int)depth) > 6 ? 4 : 3;
          make_null( );
          short null_val = -search_tt( depth-R, -beta, -beta+1, c, 0, last_cap_to );
          back_null( );
          if( null_val >= beta ){ 
             depth -= 4;
             if( depth <= 0 ) return quiesce( alpha, beta );
             }
          else if( null_val <= ( -INFINITO + MAX_PLY )){ danger = 1; depth++; }
       }
       
        
    n_mosse = gen( lista_mosse );
    
    // *** Ordinamento delle mosse ***
    if( tt[tt_loc].index == Pos.index ) sort_ab( tt[tt_loc].from, tt[tt_loc].to, lista_mosse, n_mosse );
    else sort_ab( 0,  0, lista_mosse, n_mosse );
    
    short value_to;
    short fscore = 0;
    short margin = 0;
    
    if( !c && !danger ){
        
       fscore = Pos.materiale[NERO] - Pos.materiale[BIANCO];
       if(!side) fscore = -fscore;
       if( Pos.materiale[NERO] > VAL_AL && Pos.materiale[BIANCO] > VAL_AL && 
           ((fscore + 250) < alpha || (fscore - 250) > beta)){}
       else fscore = eval();
       
       switch(depth){
          case 1:  margin =  300; break; 
          case 2:  margin =  500; break; 
          case 3:  margin =  900; break;
          default: margin = 1500;        
          } 
       }
    
    for( i=0; i < n_mosse; i++){
          prima_mossa( i, lista_mosse, n_mosse );
          
          value_to = valore_pezzi[board[lista_mosse[i].to].pezzo];
          
          if( make_move(lista_mosse[i], c )){
              nodes++;
              mosse_ab++;
              next_c = SOTTO_SCACCO( side );
              
              // *** Estensione per spinta in settima ***
              char E = 0;
              if( board[lista_mosse[i].to].pezzo == PEDONE &&
                  (TRA(lista_mosse[i].to) == 6 || TRA(lista_mosse[i].to) == 1) && !c && !next_c )E++;
                  
              // *** Estensione per ricattura ***
              if((lista_mosse[i].flag & CATTURA) && !c && !E && !next_c  && last_cap_to == lista_mosse[i].to )E++;
              
              U8 cap_to = (lista_mosse[i].flag & CATTURA) ? lista_mosse[i].to : 0x0a;
              
              // *** futily pruning ***
              if( !E &&
                  margin &&
                  !next_c && 
                  ( value_to + margin + fscore ) < alpha &&
                  !( tt[tt_loc].from == lista_mosse[i].from && tt[tt_loc].to == lista_mosse[i].to ) &&
                  !(lista_mosse[i].flag & PROMOZIONE) ){    
                     if( margin < 900 ){                
                        takeback( lista_mosse[i] );
                        continue;
                        }
                     else{ cut++; E--; }
                     }
              
               
              // *** Late move reductions ***
              if( depth >= 2 &&
                  !c &&
                  !next_c &&
                  mosse_ab >= 4 &&
                  !(lista_mosse[i].flag & CATTURA) &&
                  !(lista_mosse[i].flag & PROMOZIONE)) score = -search_tt( depth-2+E, -alpha-1,-alpha, next_c, 1, cap_to );
              else score = alpha+1;
              
              // *** Pvs *** 
              if(score > alpha){
                 if( pv_found ){
                    score = -search_tt( depth-1+E, -alpha-1,-alpha, next_c, 1, cap_to);
                    if(score > alpha && score < beta ) score = -search_tt( depth-1+E, -beta, -alpha, next_c, 1, cap_to );
                    }  
                 else score = -search_tt( depth-1+E, -beta, -alpha, next_c, 1, cap_to );
                 }
              
              takeback( lista_mosse[i] );
              
              if( abs(score) == EXIT_SEARCH ) return EXIT_SEARCH;
              
              if( score >= beta ){
                  if( tt[tt_loc].depth <= depth){
                      tt[tt_loc].depth = depth;
                      tt[tt_loc].flag  = LOWER;
                      tt[tt_loc].index = Pos.index;
                      tt[tt_loc].score = beta;
                      tt[tt_loc].from = lista_mosse[i].from;
                      tt[tt_loc].to = lista_mosse[i].to;
                      }    
                  if(!(lista_mosse[i].flag & CATTURA )){
                     kill2[ply] = kill1[ply];
                     kill1[ply] = lista_mosse[i];
                     history[lista_mosse[i].from][lista_mosse[i].to] += depth+1;
                     }
                  return beta;
                  }
              
              if( score > alpha ){ 
                 alpha = score; 
                 pv[ply][ply] = lista_mosse[i];
                 if( max_ply_raggiunto < ply ) max_ply_raggiunto = ply;
                 for( e=ply+1; e < max_ply_raggiunto; e++ )pv[ply][e] = pv[ply+1][e];
                 tt_flag = EXACT;
			     best_tt = lista_mosse[i];
			     pv_found = 1;
                 } 
              
              }
        }
           
    if(mosse_ab == 0){
	   if(c) alpha = ( -INFINITO + ply );
	   else alpha = 0;
	   }
       
    if( tt[tt_loc].depth <= depth ){
        tt[tt_loc].depth = depth;
        tt[tt_loc].flag  = tt_flag;
        tt[tt_loc].index = Pos.index;
        tt[tt_loc].score = alpha;
        tt[tt_loc].from = best_tt.from;
        tt[tt_loc].to = best_tt.to;
        } 
    
                 
    return alpha;

}

//////////////////////////////////////////////////////////////////////////

short quiesce( short alpha, short beta ) {
      
    if(!(nodes % 1024) && ( get_ms() - start_time ) > tempo_massimo ) return EXIT_SEARCH;
    
    if( ply >= MAX_PLY ) return eval();
      
    mossa lista_mosse[256];    
    U8 c,  n_mosse, mosse_ab = 0; 
    short i, score, qs_val = 0;
    
    c = SOTTO_SCACCO( side );
     
    if(!c){    
       // lazy eval
       short fscore = Pos.materiale[NERO] - Pos.materiale[BIANCO];
       if(!side) fscore = -fscore;
       if( Pos.materiale[NERO] > VAL_AL && Pos.materiale[BIANCO] > VAL_AL && 
           ((fscore + 250) < alpha || (fscore - 250) > beta) ) qs_val = fscore;     
       else qs_val = eval();
       
       if( qs_val >= beta ) return beta;
       if( qs_val > alpha ) alpha = qs_val;
       
       }
   
    if(c) n_mosse = gen( lista_mosse );
    else n_mosse = gen_qs( lista_mosse );
    
    sort_qs( lista_mosse, n_mosse );
    
    for( i=0; i< n_mosse; i++){
        prima_mossa( i, lista_mosse, n_mosse );
        
        // delta pruning    
        if( !c && ( valore_pezzi[board[lista_mosse[i].to].pezzo] + 1 + qs_val ) < alpha ) continue;
            
        if( make_move(lista_mosse[i], c )){
             nodes++; 
             mosse_ab++;            
             score = -quiesce( -beta, -alpha );
             takeback( lista_mosse[i] );
        
             if( abs(score) == EXIT_SEARCH ) return EXIT_SEARCH;
             if( score >= beta ) return beta; 
             if( score > alpha ) alpha = score;
                
            }
        }
        
    if( mosse_ab == 0 && c ) return ( -INFINITO + ply );
        
    return alpha;

}


//////////////////////////////////////////////////////////////////////////


void aggiorna_pv( short score ){
     
     int x;
     
     printf("%2d  %6d %8d %12llu ", max_iteractions, score,( get_ms() - start_time )/10, nodes);
     fflush(stdout);
			
     for( x=0; x < max_iteractions && x <=8 && x<max_ply_raggiunto; x++ ){
         print_move( pv[0][x] );
         fflush(stdout);
         }
         
     printf("\n");

}

//////////////////////////////////////////////////////////////////////////

const int to_sort[7] =   { 0, 1000, 2000, 6000 , 3000, 4000 , 5000 }; 
const int from_sort[7] = { 0,    1,    2,    6 ,    3,    4,     5 }; 


void sort_ab( U8 b_from, U8 b_to, mossa *mosse, U8 n ){
     
     U8 i;
     
     for( i=0; i<n; i++ ){
         
         if( b_from == mosse[i].from && b_to == mosse[i].to ) mosse[i].score = 12000;
          
         // valore per le catture max 5999, min 994
         else if( mosse[i].flag & CATTURA ) 
              mosse[i].score = to_sort[board[mosse[i].to].pezzo] - from_sort[board[mosse[i].from].pezzo];
              
         else if( mosse[i].flag & PROMO_D ) mosse[i].score = 1200;
             
         else if( kill1[ply].from == mosse[i].from && kill1[ply].to == mosse[i].to ) mosse[i].score = 800; 
             
         else if( kill2[ply].from == mosse[i].from && kill2[ply].to == mosse[i].to ) mosse[i].score = 750;
         
         else if( mosse[i].flag & PROMO_C ) mosse[i].score = 710;    
                   
         else mosse[i].score = MIN(history[mosse[i].from][mosse[i].to],700 );
         
         }        
}

//////////////////////////////////////////////////////////////////////////

void sort_qs( mossa *mosse, U8 n ){
     
     U8 i;
     
     for( i=0; i<n; i++ ){
           
         if( mosse[i].flag & CATTURA ) 
              mosse[i].score = to_sort[board[mosse[i].to].pezzo] - from_sort[board[mosse[i].from].pezzo];
                   
         else mosse[i].score = 0;
         
         }         
}


//////////////////////////////////////////////////////////////////////////


void prima_mossa( U8 f, mossa *mosse, U8 n_mosse ){
    
    U8 i, ti = f;
    mossa tm;
    short bs = 0;
           
    for( i=f; i<n_mosse; i++ ) if( mosse[i].score > bs ) { bs =  mosse[i].score; ti = i;}
           
    tm = mosse[f];
    mosse[f] = mosse[ti];
    mosse[ti] = tm;
                                   
}

//////////////////////////////////////////////////////////////////////////


void make_null( ){
    
    // Facciamo il debug della posizione per il take_back();
    Pos_array[ply] = Pos; 
    
    // Togliamo la casa ep      
    U8 temp_ep = Pos.ep;
    Pos.ep = OFF_BOARD;
    Pos.index ^= zobrist.ep[Pos.ep] ^ zobrist.ep[temp_ep];      
                
    // Modifichiamo le altre variabili
    Pos.fifty = 0;
    Pos.index ^= zobrist.side;
    side ^= 1;
    hply++;
    ply++;
    
    hash_partita[hply] = Pos.index; 
     
 }
 
////////////////////////////////////////////////////////////////////////

void back_null( ){
      
     ply--;
     hply--;
	 side ^= 1;
     Pos = Pos_array[ply];
           
 }
 
//////////////////////////////////////////////////////////////////////////
// ***********************************************************************
//  EVAL *****************************************************************
// ***********************************************************************
//////////////////////////////////////////////////////////////////////////

#define DOPPIATO		         -15
#define ISOLATO		             -15
#define PASSATO			          10
#define DIFESA                    10
#define MOB_ALF                    3

//////////////////////////////////////////////////////////////////////////

int mobilita_alfiere( int i ){
    
    int mob = 0, to;
    
    for( to = i + 15; IS_BOARD(to) && !board[to].pezzo; to += 15 ) mob++;
    for( to = i - 15; IS_BOARD(to) && !board[to].pezzo; to -= 15 ) mob++;
    for( to = i + 17; IS_BOARD(to) && !board[to].pezzo; to += 17 ) mob++;
    for( to = i - 17; IS_BOARD(to) && !board[to].pezzo; to -= 17 ) mob++;
    
    return mob * MOB_ALF;

}

//////////////////////////////////////////////////////////////////////////

int eval(){
    
   U8 f, i, C, T ;
   int score = 0;
   U8 finale = 0;
   U8 pos_ped[2][8];
   U8 num_ped[2] = {0,0};
   U8 coppia_al[2] = {0,0};
   int val_pezzi[2] = {0,0};
   U8 max_nero[10] = {0,0,0,0,0,0,0,0,0,0};
   U8 min_bianco[10] = {8,8,8,8,8,8,8,8,8,8};
   U8 col_ped[2][10] = {{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0}};
   
   /********************************************************/
    
   // valutazione pezzi e pedoni bianchi
   for( f=0; f < Pos.pezzi_tot[BIANCO]; f++ ){      
      i = pezzi_loc[BIANCO][f];
      switch( board[i].pezzo ){
          case PEDONE :
               T = TRA(i);
               C = COL(i)+1;
               pos_ped[BIANCO][num_ped[BIANCO]++] = i;
               score -= ped_med[BIANCO][i];
               col_ped[BIANCO][C]++;
               if( T < min_bianco[C] ) min_bianco[C] = T;
               break;
          case CAVALLO :     
               score -= cav_med[BIANCO][i];  
               val_pezzi[BIANCO] += VAL_CA;
               break;
          case ALFIERE :
               coppia_al[BIANCO]++;
               score -= mobilita_alfiere(i);
               val_pezzi[BIANCO] += VAL_AL;
               break;
          case TORRE :
               score -= tor_med[BIANCO][i];
               val_pezzi[BIANCO] += VAL_TO;
               break;
          case DONNA :
               val_pezzi[BIANCO] += VAL_DO;
               break;  
         }
      }
      
   // valutazione pezzi e pedoni neri
   for( f=0; f < Pos.pezzi_tot[NERO]; f++ ) {      
      i = pezzi_loc[NERO][f];
      switch( board[i].pezzo ){
          case PEDONE :
               T = TRA(i);
               C = COL(i)+1;
               pos_ped[NERO][num_ped[NERO]++] = i;
               score += ped_med[NERO][i];
               col_ped[NERO][C]++;
               if( T > max_nero[C] ) max_nero[C] = T;
               break;
          case CAVALLO :     
               score += cav_med[NERO][i];  
               val_pezzi[NERO] += VAL_CA;
               break;
          case ALFIERE :
               coppia_al[NERO]++;
               score += mobilita_alfiere(i);
               val_pezzi[NERO] += VAL_AL;
               break;
          case TORRE :
               score += tor_med[NERO][i];
               val_pezzi[NERO] += VAL_TO;
               break;
          case DONNA :
               val_pezzi[NERO] += VAL_DO;
               break;  
         }
      }
      
   /********************************************************/
   
   // Patta per insufficiente materiale
   if( val_pezzi[BIANCO] <= VAL_AL && val_pezzi[NERO] <= VAL_AL && !num_ped[BIANCO] && !num_ped[NERO] ) return 0;
   
   
   // Siamo nel finale ( 5 alfieri ) ?
   if( val_pezzi[BIANCO] <= FINALE && val_pezzi[NERO] <= FINALE ) finale = 1;    
   
   
   // Materiale
   score += Pos.materiale[NERO] - Pos.materiale[BIANCO];
   
   // coppia degli alfieri   
   if( coppia_al[BIANCO] > 1 ) score -= 30;  
   if( coppia_al[NERO]   > 1 ) score += 30;
   
   /********************************************************/
   
   for( f=0; f < num_ped[BIANCO]; f++ ){      
          i = pos_ped[BIANCO][f];
          C = COL(i)+1;
          T = TRA(i);
          if( col_ped[BIANCO][C] > 1 ) score -= DOPPIATO;
          if( !col_ped[BIANCO][C-1] && !col_ped[BIANCO][C+1] ) score -= ISOLATO;
          if( T >= max_nero[C-1] && T >= max_nero[C] && T >= max_nero[C+1] ) score -= PASSATO * T;
          } 
   
   for( f=0; f < num_ped[NERO]; f++ ){      
          i = pos_ped[NERO][f];
          C = COL(i)+1;
          T = TRA(i);
          if( col_ped[NERO][C] > 1 ) score += DOPPIATO;
          if( !col_ped[NERO][C-1] && !col_ped[NERO][C+1] ) score += ISOLATO;
          if( T <= min_bianco[C-1] && T <= min_bianco[C] && T <= min_bianco[C+1] ) score += PASSATO * (7-T);
          }
       
      
   if(finale) score += re_fin[Pos.re[NERO]] - re_fin[Pos.re[BIANCO]];
   
   else{ 
      score += re_med[NERO][Pos.re[NERO]] - re_med[BIANCO][Pos.re[BIANCO]];
      
      if( re_med[BIANCO][Pos.re[BIANCO]] > 0 ){
         if( board[Pos.re[BIANCO] + 16].flag == ( FLAG_BIANCO | FLAG_PEDONE ))score -= DIFESA;
         if( board[Pos.re[BIANCO] + 15].flag == ( FLAG_BIANCO | FLAG_PEDONE ))score -= DIFESA;
         if( board[Pos.re[BIANCO] + 17].flag == ( FLAG_BIANCO | FLAG_PEDONE ))score -= DIFESA;
         }
      if( re_med[NERO][Pos.re[NERO]] > 0 ){   
         if( board[Pos.re[NERO] - 16].flag == ( FLAG_NERO | FLAG_PEDONE ))score += DIFESA;
         if( board[Pos.re[NERO] - 15].flag == ( FLAG_NERO | FLAG_PEDONE ))score += DIFESA;
         if( board[Pos.re[NERO] - 17].flag == ( FLAG_NERO | FLAG_PEDONE ))score += DIFESA;
        }
      
      }
       
   
   /********************************************************/
   
   return (side) ? score : -score;   
    
}


////////////////////////////////////////////////////////////////////////

